package com.hamaf.hikyaku.access;

import java.sql.Connection;

import javax.naming.InitialContext;
import javax.sql.DataSource;

/**
 * <p>^CgFTomcatPooling is Tomcat̃RlNVv[擾.</p>
 * <p>FW̃T|[gŁATomcat̃RlNVv[gp܂</p>
 * <br>TomCat"JDBC/_(name)_"Œ`ꂽARlNVv[擾B
 * <br>_(name)_̃ftHg<b>Hikyaku</b>ƂȂ܂B
 * 
 * <p>쌠: Copyright (c) 2007/06/08</p>
 * @author y-hamanaka
 * @version 1.0
 */
public final class TomcatPooling implements DbConnectInterface {

  private static final String TOMCAT = "java:comp/env/jdbc/";
  private static final String DSNAME = "Hikyaku";

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.access.DbConnectInterface#getConnection(java.lang.String)
   */
  public Connection getConnection(String prm) throws Exception {
    StringBuilder sb = new StringBuilder(TOMCAT);
    if (prm == null || prm.length() == 0) {
      sb.append(DSNAME);
    }
    else {
      sb.append(prm);
    }
    InitialContext ic = new InitialContext();
    DataSource ds = (DataSource)ic.lookup(sb.toString());
    return ds.getConnection();
  }

}
