package com.hamaf.hikyaku.containar;

import java.io.File;
import java.net.URL;

import org.picocontainer.DefaultPicoContainer;
import org.picocontainer.PicoContainer;
import org.picocontainer.script.ScriptedContainerBuilder;
import org.picocontainer.script.ScriptedContainerBuilderFactory;

/**
 * <p>^CgFDiNanoContainar is implementation Pico Container.</p>
 * <p>FPicoRei[ɂDiContainer̎sĂ܂B</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2007/05/17</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class DiPicoContainar implements DiContainer {
  
  private PicoContainer _pico = null;
  
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.containar.DiContainer#initialize(com.hamaf.hikyaku.containar.DiFactory.DiDefType, java.lang.String)
   */
  public void initialize(String flnm) {
    try {
      ScriptedContainerBuilderFactory scbf;
    	File inf = new File(flnm);
    	if (inf.exists()) {
    		scbf = new ScriptedContainerBuilderFactory(inf);
    	} else {
        URL url = this.getClass().getClassLoader().getResource(flnm);
        scbf = new ScriptedContainerBuilderFactory(url);
    	}
      ScriptedContainerBuilder bldr = scbf.getContainerBuilder();
      
      PicoContainer parent = new DefaultPicoContainer();
      _pico = bldr.buildContainer(parent, "SOME_SCOPE", true);
    } catch (Exception xe) {
      xe.printStackTrace();
    }    
  }
  
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.distribute.DiContainer#getComponent(java.lang.Object)
   */
  public final Object getComponent(Object key) throws Exception {
    if (_pico == null) {
      throw new IllegalStateException("Contorol information not Found!!!");
    }
    return _pico.getComponent(key);
  }

}
