package com.hamaf.hikyaku.dataobject;

import java.util.Collection;
import java.util.Set;

/**
 * <p>^CgFDetailItemsInterfaceis f[^擾pDataObject@ʃC^[tF[X.</p>
 * <p>: Pe[uPf[^擾ׂ̃IuWFNgpC^[tF[X</p>
 * <br>ڒlvNX̗p@
 * <ol>
 *   <li>PrimaryKeyڂ<code>setItemValue()</code>Œlݒ肷
 *   <li>擾ڂ̍ڔԍ<code>setRequestItem()</code>Őݒ肷
 *   <li>f[^擾NXĂяo
 *   <li><code>getItemValue()</code>ōڒl擾
 * </ol>
 * Tv
 * <pre>
 *     XxxxxInstance xinst = new XxxxxInstance();
 *     xinst.setItemValue(XxxxxInstance.UID, "0010");
 *     xinst.setRequestItem(XxxxxInstance.UNAME);
 *     xinst = X____Get.xxx(xinst);
 *     if (xinst.isNotFound()) {
 *       // NotFound̏
 *     }
 *     else {
 *       String unm = xinst.getItemValue(XxxxxInstance.UNAME);
 *     }
 * </pre>
 * <br>r䓙̋ʊǗڂƂĈȉ̍ڂǗ
 * <ol>
 *   <li>XV - UPDT
 *   <li>XV - UPTM
 *   <li>[U[ID - UUSR
 *   <li>XVvNX - UPGM
 *   <li>폜tO - DEL
 * </ol>
 * <p>쌠: Copyright (c) 2004/06/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public interface DetailItemsInterface {

  public enum COMMFLD {
    UPDT("UPD_DATE"),
    UPTM("UPD_TIME"),
    UUSR("UPD_USER"),
    UPGM("UPD_PGM"),
    DEL("DEL_FLG");

    private final String _val;
    COMMFLD(String val) { _val = val; }
    public String getVal() { return _val; }
  }

  public enum USE_FLG {
    USE("0"), DEL("1");
    private final String _val;
    USE_FLG(String v) { _val = v; }
    public String getVal() { return _val; }
  }

  /**
   * Method setRequestItem is setting get item.
   * <br>擾鍀ڂڔԍŎw肷B
   * @param item an <code>int</code> : item number
   * @throws IllegalArgumentException
   */
  public void setRequestItem(int item) throws IllegalArgumentException;

  /**
   * Method clearRequest is clear get item.
   * <br>擾NA鍀ڂڔԍŎw肷B
   * @param item an <code>int</code> : item number
   * @throws IllegalArgumentException
   */
  public void clearRequest(int item) throws IllegalArgumentException;

  /**
   * Describe <code>setAllRequest</code> method : set all items get.
   * <br>ݒ肳ĂSڂ擾ݒsB
   */
  public void setAllRequest();

  /**
   * Method getItemCount is return request item count.
   * <br>擾鍀ڐ߂B
   * @return int
   */
  public int getItemCount();

  /**
   * Describe <code>getItemNoList</code> method : return item no list.
   * <br>ڔԍ̃Xg߂B
   * <br>
   * @return a <code>Set&lt;Integer&gt;</code> :
   */
  public Set<Integer> getItemNoList();

  /**
   * Describe <code>getFieldNameList</code> method : return field name list.
   * <br>ږ̃Xg߂B
   * <br>
   * @return a <code>Collection&lt;String&gt;</code> :
   */
  public Collection<String> getFieldNameList();

  /**
   * Method isRequestItem return is reuest item-no.
   * <br>w肳ꂽڔԍ擾Ώۂ߂B
   * <br>擾Ώۂ̂Ƃ<b>true</b>
   * @param no an <code>int</code> : `FbN鍀ڔԍ
   * @return boolean
   */
  public boolean isRequestItem(int no);

  /**
   * Describe <code>isKeyFld</code> method : check key field.
   * <br>w肳ꂽڔԍKeyڂ̏ꍇ <b>true</b> ߂B
   * @param no a <code>boolean</code> : ڔԍ
   * @return a <code>boolean</code> : keyڂ̏ꍇ <code>true</code>
   */
  public boolean isKeyFld(int no);

  /**
   * Method setItemValue is setting item value.
   * @param item an <code>int</code> : ڔԍ
   * @param val a <code>String</code> : l̕
   * @throws IllegalArgumentException
   */
  public void setItemValue(int item, String val) throws IllegalArgumentException;

  /**
   * Describe <code>setFldValue</code> method : setting item value by Field name.
   * <br>tB[hŒlݒ肷B
   *
   * @param fld a <code>String</code> : tB[h
   * @param val a <code>String</code> : ݒ肷l
   */
  public void setFldValue(String fld, String val);

  /**
   * Method getItemValue is get Item Value.
   * @param item an <code>int</code> : ڔԍ
   * @return a <code>String</code> : l
   * @throws IllegalArgumentException
   */
  public String getItemValue(int item) throws IllegalArgumentException;

  /**
   * Describe <code>getFldValue</code> method : get item value by Field name.
   * <br>tB[hŒl擾B
   *
   * @param fld a <code>String</code> : tB[h
   * @return a <code>String</code> : l
   */
  public String getFldValue(String fld);

  /**
   * Describe <code>setNotFound</code> method : set not found condision.
   * <br>f[^Ȃ̏ꍇɂ̐ݒsB
   */
  public void setNotFound();

  /**
   * Describe <code>clearNotFound</code> method : clear not found condision.
   * <br>f[^Ȃ̐ݒNABif[^ɂj
   */
  public void clearNotFound();

  /**
   * Describe <code>isNotFound</code> method : is data not found ?
   * <br>f[^̗LmFBf[^Ȃ̏ꍇ<code>true</code>
   * @return a <code>boolean</code> : f[^Ȃ̏ꍇ <b>true</b>
   */
  public boolean isNotFound();

  /**
   * Describe <code>setCommFld</code> method : set common field.
   * <br>ʍڂ̐ݒsB
   *
   * @param fld a <code>COMMFLD</code>
   * @param val a <code>String</code> : ݒ肷l
   */
  public void setCommFld(COMMFLD fld, String val);

  /**
   * Describe <code>getCommFld</code> method : get common field value.
   * <br>ʍڂ̐ݒl߂B
   *
   * @param fld a <code>COMMFLD</code> :
   * @return a <code>String</code> :
   */
  public String getCommFld(COMMFLD fld);

  /**
   * Describe <code>getField</code> method : ږ߂.
   * <br>w肳ꂽڔԍDBږ߂
   *
   * @param pos an <code>int</code> : ڔԍ
   * @return a <code>String</code> : ږ
   */
  public String getField(int pos);



  /**
   * Describe <code>getKeyFlds</code> method : keyڔԍ̔z߂.
   *
   * @return a <code>int[]</code> : L[ڔԍ̔z
   */
  public int[] getKeyFlds();

  /**
   * Describe <code>getConstCond</code> method : Œ߂.
   *
   * @return a <code>String</code> : 
   */
  public String getConstCond();
  /**
   * Describe <code>setConstCond</code> method : Œݒ肷.
   *
   * @param a <code>String</code> : 
   */
  public void setConstCond(String constCond);

  /**
   * Describe <code>getGroup</code> method : O[vڂ߂.
   *
   * @return a <code>String[]</code> : O[v
   */
  public String getGroup();
  /**
   * Describe <code>setGroup</code> method : group ݒ肵܂.
   * <br>B
   *
   * @param group a <code>String</code> :
   */
  public void setGroup(String group);

  /**
   * @return VXeID
   */
  public String getSysId();
  /**
   * @param del : VXeID ݒ肵܂B
   */
  public void setSysId(String del);

}
