package com.hamaf.hikyaku.dataobject;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

/**
 * <p>^CgFJspItemsMapping is Jsp items : DetailItem items mapping.</p>
 * <p>FJSP̍ڂƃf[^IuWFNg̍ڂ̑ΉtǗ</p>
 * <br>p@FRXgN^[<code>addItem()</code>ɂAJSP̍ږDataObj̍ڂRÂ
 * <pre>
 * TvER[h
 * public class XxxMapping extends JspItemsMapping {
 *   public XxxMapping() {
 *     addItem("JSPږ", DataObj.ږ);
 *        E
 *         E
 *   }
 * </pre>
 * 
 * <p>쌠: Copyright (c) 2007/05/28</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class JspItemsMapping implements Iterable<String> {
  
  protected Map<String, Integer> _items = new HashMap<String, Integer>();
  
  /**
   * Describe <code>addItem</code> method : 擾ڔԍ:\ږ̗pMapւ̓o^.
   * <br>_items(<code>Map</code>)ɍڔԍJSPł̍ږ̕Rto^B
   * <ol>
   *  <li>key : JSPŎw肳Ă鍀ڂ̖(<code>String</code>)
   *  <li>value : DetailItemsInterfaceNX̍ڔԍ
   * </ol>
   * @param jspnm a <code>String</code> : JSPł̍ږ
   * @param pos an <code>int</code> : f[^ObjectŒ`Ă鍀ڈʒu
   */
  public final void addItem(String jspnm, int pos) {
    _items.put(jspnm, pos);
  }

  /* (Javadoc Ȃ)
   * @see java.lang.Iterable#iterator()
   */
  public final Iterator<String> iterator() {
    return _items.keySet().iterator();
  }
  
  /**
   * Describe <code>getDtoNo</code> method : ږ̂ɑΉڔԍ߂.
   * 
   * @param fld a <code>String</code> : ږ
   * @return a <code>Integer</code> : ڔԍ
   */
  public final Integer getDtoNo(String fld) {
    return _items.get(fld);
  }
  
  /**
   * Describe <code>getFldNm</code> method : ڔԍɑΉږ̂߂.
   * 
   * @param pos a <code>Integer</code> : ڔԍ
   * @return a <code>String</code> : ږ
   */
  public final String getFldNm(int pos) {
    Set<Map.Entry<String, Integer>> ment = _items.entrySet();
    for (Map.Entry<String, Integer> kvdt : ment) {
      if (kvdt.getValue() == pos) {
        return kvdt.getKey();
      }
    }
    return null;
  }
  
  /**
   * Describe <code>contains</code> method : ږ̂`Ă邩`FbN.
   * <br>`ĂꍇA,code>true</code>߂B
   * 
   * @param fld a <code>String</code> : ږ
   * @return a <code>boolean</code> : ݂ꍇAtrue
   */
  public final boolean contains(String fld) {
    return _items.containsKey(fld);
  }
  
  /**
   * Describe <code>containsValue</code> method : ڔԍ`Ă邩`FbN.
   * <br>`ĂꍇA,code>true</code>߂B
   * 
   * @param pos a <code>Integer</code> : ڔԍ
   * @return a <code>boolean</code> : ݂ꍇAtrue
   */
  public final boolean containsValue(Integer pos) {
    return _items.containsValue(pos);
  }
  
  /**
   * Describe <code>isEmpty</code> method : JSPږDataObjڔԍ̃}bsOێȂꍇ true Ԃ܂B.
   * 
   * @return a <code>boolean</code> : }bsOێȂꍇ true
   */
  public final boolean isEmpty() {
    return _items.isEmpty();
  }

}
