package com.hamaf.hikyaku.extension;

/**
 * <p>^Cg: AppricationLog write interface.</p>
 * <p>: AvP[VOo̓C^[tF[XB</p>
 * <br><b>AppLogOut.properties</b>
 * <b>LogOutName,LogOutPath,LogOutLevel,LogLineCount,SystemOut</b> QƂ܂B
 * <br>ePropertyl̏ڍׂAppLogOut.propertiesQ
 * <ul>
 *   <li>o͐̃pX<b>LogOutPath,</b>󂯎Bݒ̏ꍇDeultʒuB
 *   <li>o͐惌x<b>LogOutLevel</b>ݒ肷B
 *   <li>t@C<b>LogOutName_(date + time)_.log</b>ƂB
 *   <li>o̓x<b>DEBUG,INFO,ERROR</b>ƂB
 *   <li>o͌`<b>[t ][o̓x]massage</b>ƂB
 *   <li>o͍s<b>LogLineCount</b>𒴂VOt@Cɏo
 *   <li><b>SystemOut</b><b>Yes</b>̏ꍇ́AWo͂ɂo
 * </ul>
 * @author Hamanaka
 * @version 1.0
 */
public interface AppLogOut {

  /**
   * Describe constant <code>LEVEL_ERROR</code> : General Error level code.
   *
   */
  public final static int LEVEL_ERROR = 0;
  /**
   * Describe constant <code>LEVEL_INFO</code> : Information level code.
   *
   */
  public final static int LEVEL_INFO = 1;
  /**
   * Describe constant <code>LEVEL_DEBUG</code> : Debug level code.
   *
   */
  public final static int LEVEL_DEBUG = 2;

  /**
   * Describe <code>setLevel</code> method : set output level.
   * <br>Oo͂̃xݒ肷B
   * <br><code>PreserveBSLinfo.getLogOutLevel()</code>Ŏ擾lɂ
   * <br><b>LEVEL_DEBUG,LEVEL_INFO,LEVEL_ERROR</b>̂ꂩݒ肳B
   * <br>ʏ͌ĂяoKv͂܂BAppLogInfo.init()Ăяoꍇɗp܂B
   */
  public void setLevel(String pid);

  /**
   * Describe <code>debug</code> method : Debug log write.
   * <br>fobOpOo
   * <br>o̓x<b>LEVEL_DEBUG</b>̂Ƃ̂ݏo͂B
   * @param msg a <code>String</code> : Message
   */
  public void debug(String msg);

  /**
   * Describe <code>error</code> method : Error log write.
   * <br>G[pOo
   * <br>o̓x<b>LEVEL_DEBUG or LEBEL_INFO</b>̂Ƃo͂B
   * @param msg a <code>String</code> : Message
   */
  public void info(String msg);

  /**
   * Describe <code>fatal</code> method : Fatal log write.
   * <br><b>Fatal</b>pOo
   * <br>ɏo͂B
   * @param msg a <code>String</code> : Message
   */
  public void error(String msg);

  /**
   * Describe <code>fclose</code> method : file close.
   * <br>o<b>File</b>N[YB
   */
  public void fclose();

}
