package com.hamaf.hikyaku.plugIn.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.plugIn.dto.VInitDto;
import com.hamaf.hikyaku.plugIn.process.InitInfAcquisition;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFInitDispCreate is .</p>
 * <p>F</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/02/24</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class InitDispCreate extends ProcessBase {
  
  public enum INIT_ITEMS {
    plgId( VInitDto.PLUGIN_ID ),
    initId( VInitDto.INIT_ID ),
    title( VInitDto.DISPLAY ),
    proc( VInitDto.PROCESS ),
    act( VInitDto.ACTION ),
    opt( VInitDto.ADD_OPTION ),
    icon( VInitDto.ICON );
    
    private int val;
    INIT_ITEMS(int argV) { val = argV; }
    public int getVal() { return val; }   
    
  }

  private InitInfAcquisition _iia = null;
  /**
   *  Creates a new <code>InitDispCreate.java</code> instance.
   * <br>Default Constructor
   */
  public InitDispCreate(InitInfAcquisition iia) {
    _iia = iia;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    msg.setResList(_iia.getCenterDsp((UserDto)session.getAttribute(LogInCheck.USER_INF)));
    msg.setWorkBuff(_iia.getRightDsp((UserDto)session.getAttribute(LogInCheck.USER_INF)));
    return msg;
  }

}
