package com.hamaf.hikyaku.plugIn.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.plugIn.dto.VRetrieveDto;
import com.hamaf.hikyaku.plugIn.process.RetrieveInfAcquisition;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFRetrieveCreate is .</p>
 * <p>F</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/06/23</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class RetrieveCreate extends ProcessBase {
  
  public enum RETRIEVE_ITEMS {
    plgId( VRetrieveDto.PLUGIN_ID ),
    retrieveId( VRetrieveDto.RETRIEVE_ID ),
    title( VRetrieveDto.DISPLAY ),
    proc( VRetrieveDto.PROCESS ),
    act( VRetrieveDto.ACTION ),
    opt( VRetrieveDto.ADD_OPTION ),
    icon( VRetrieveDto.ICON ),
    sval(0);
    
    private int val;
    RETRIEVE_ITEMS(int argV) { val = argV; }
    public int getVal() { return val; }       
  }

  private RetrieveInfAcquisition _rac = null;  

  /**
   *  Creates a new <code>RetrieveCreate.java</code> instance.
   * <br>Default Constructor
   * @param rac
   */
  public RetrieveCreate(RetrieveInfAcquisition rac) {
    _rac = rac;
  }

  private final String RET_VAL = "sval";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    msg.setResList(_rac.getRetrieveInf(msg.getReqStr(RET_VAL),
        (UserDto)session.getAttribute(LogInCheck.USER_INF)));
    return msg;
  }

}
