package com.hamaf.hikyaku.security.ui;

import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.security.process.GroupMemberProcess;
import com.hamaf.hikyaku.ui.ProcessBase;


/**
 * <p>^CgFGroupMemberMod is .</p>
 * <p>F</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/05/24</p>
 * @author yoshinori
 * @version 1.0
 */
public class GroupMemberMod extends ProcessBase {

	private GroupMemberProcess _gmp = null;

	/**
	 *  Creates a new <code>GroupMemberMod.java</code> instance.
	 * <br>Default Constructor
	 * @param gmp
	 */
	public GroupMemberMod(GroupMemberProcess gmp) {
		_gmp = gmp;
	}

  private final String MODOK = "GrpMemMod";
  private final String MODMSG = "GrpMemModInf";
  private final String GETGRP = "dispGroup";
	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	public CommonMessage exec(CommonMessage msg) throws Exception {
		String gid = msg.getReqStr(GroupMemberModIni.RM_KEY);
		if (gid.length() > 0) {
			_gmp.changeUser(gid, cnvList(msg.getReqStr(GroupMemberModIni.RM_UID)));
			_gmp.changeBelong(gid, cnvList(msg.getReqStr(GroupMemberModIni.RM_GID)));
		}
    msg.setResMsg(MODOK, "1");
    StringBuilder sb = new StringBuilder();
    sb.append(msg.getReqStr(GETGRP));
    sb.append("\\n");
    sb.append(resource.getString(MODMSG));
    msg.setResMsg(MODMSG, sb.toString());		
		return msg;
	}

	private List<String> cnvList(String val) {
		List<String> ret = new ArrayList<String>();
		String[] vals = val.split(",");
		for (int i = 0; i < vals.length; i++) {
		  if (vals[i] != null && vals[i].length() > 0) {
		    ret.add(vals[i]);
		  }
		}
		return ret;
	}
}
