package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.dto.MessageDto;
import com.hamaf.hikyaku.security.process.MessageProcess;
import com.hamaf.hikyaku.security.ui.mapping.MessageMap;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFMessageDelIni is .</p>
 * <p>FbZ[W폜̑Ώۃf[^擾</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/01/27</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class MessageDelIni extends StandardDetailProcess {

	private MessageProcess _mp = null;

	/**
	 * Creates a new <code>MessageDelIni.java</code> instance.
	 * <br>Default Constructor
	 * @param mp
	 * @param jim
	 */
	public MessageDelIni(MessageProcess mp, MessageMap jim) {
		super();
		_mp = mp;
		_jim = jim;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new MessageDto();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected DetailItemsInterface callControl(DetailItemsInterface dii)
			throws Exception {
		return _mp.findByPrimarikey((MessageDto)dii);
	}

}
