package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.dto.VPossibleDto;
import com.hamaf.hikyaku.security.process.PossibleProcess;
import com.hamaf.hikyaku.security.ui.mapping.VPossibleInfMap;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFPossibleModIni is .</p>
 * <p>FύXʏ\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/06/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PossibleModIni extends StandardDetailProcess {

  private PossibleProcess _pp = null;

  /**
   *  Creates a new <code>PossibleModIni.java</code> instance.
   * <br>Default Constructor
   * @param pp
   */
  public PossibleModIni(VPossibleInfMap vim, PossibleProcess pp) {
    _pp = pp;
    _jim = vim;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _pp.findByPrimaruKey((VPossibleDto)dii);
  }

  @Override
  protected CommonMessage editItems(CommonMessage argMsg) throws Exception {
    StringBuilder sb = new StringBuilder();
    sb.append(argMsg.getResMsg("gcode"));
    sb.append("-");
    sb.append(argMsg.getResMsg("gname"));
    argMsg.setResMsg("grpname", sb.toString());
    return argMsg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VPossibleDto();
  }

}
