package com.hamaf.hikyaku.taglibs;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.util.JspUtils;
import com.hamaf.hikyaku.util.MessageUtil;


/**
 * <p>^Cg: ڎ擾p^OuNX.</p>
 * <p>: w肳ꂽڒl߂B</p>
 * <p>쌠: Copyright (c) 2002</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>item</td>
 *     <td>K{</td>
 *     <td>鍀ږw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>addVal</td>
 *     <td>C</td>
 *     <td>ڒľɕ\镶w肷B</td>
 *   </tr>
 *   <tr>
 *     <td>nl2br</td>
 *     <td>C</td>
 *     <td>sR[h&lt;br&gt;ɕϊꍇA"yes"w肷B</td>
 *   </tr>
 *   <tr>
 *     <td>nocnv</td>
 *     <td>C</td>
 *     <td>^O̕ϊsȂꍇA"yes"ݒ肵܂B</td>
 *   </tr>
 * </table>
 *
 * @author y-hamanaka
 * @version 1.0
 */
public class DispItem extends TagSupport {

  private static final long serialVersionUID = -3210418723780241669L;

  private String _item = null;
  private String _addVal = null;
  private String _nl2br = null;
  private String _nocnv = null;

  /**
   * ^OJnɌĂяo
   *
   * @return <code>EVAL_BODY_TAG</code>
   * @throws JspException
   */
  public final int doStartTag() throws JspException {
    //l̊mF
    if (_item == null ) {
      return SKIP_BODY;
    } // end of if ()

    boolean ncnv = false;
    if (_nocnv != null && _nocnv.length() > 0) {
    	if (_nocnv.toUpperCase().startsWith("T") ||
    			_nocnv.toUpperCase().startsWith("Y")) ncnv = true;
    }
    StringBuilder val = new StringBuilder();
    val.append(MessageUtil.getItem(pageContext.getRequest(), _item, ncnv));
    if (_addVal != null && !val.equals("")) {
      val.append(" ");
      val.append(_addVal);
    }
    String dsp = val.toString();
    if (_nl2br != null && _nl2br.length() >0 ) {
      if (_nl2br.toLowerCase().startsWith("y") ||
          _nl2br.toLowerCase().startsWith("t")) dsp = JspUtils.changeNL2BR(dsp);
    }

    try {
      pageContext.getOut().println(dsp);
    } catch (Exception ioe) {
      throw new JspException(ioe.getMessage());
    }
    release();
    return SKIP_BODY;
  }

  /**
   * ^OIɌĂяo
   *
   * @return <code>EVAL_PAGE</code>
   * @throws JspException
   */
  public final int doEndTag() throws JspException {
    return EVAL_PAGE;
  }

  /**
   * <CODE>item</CODE>̐ݒ
   * @param item Value to assign to (String)item.
   */
  public final void setItem(String item) {
    _item = item;
  }

  /**
   * <CODE>addVal</CODE>̐ݒ
   * @param addVal Value to assign to (String)addVal.
   */
  public final void setAddVal(String addVal) {
    _addVal = addVal;
  }

  /**
   * @param nl2br nl2br ݒ肵܂B
   */
  public final void setNl2br(String nl2br) {
    _nl2br = nl2br;
  }

  /**
	 * @param nocnv Zbg nocnv
	 */
	public void setNocnv(String nocnv) {
		_nocnv = nocnv;
	}

	/**
   * ^O̓ԂZbg
   */
  public void release() {
    _item = null;
    _addVal = null;
    _nl2br = null;
    _nocnv = null;
    super.release();
  }

}