package com.hamaf.hikyaku.taglibs;

import java.text.MessageFormat;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.security.ui.UserIconMod;

/**
 * <p>^CgFDispUserIcon is .</p>
 * <p>F[U[Icon\pimage^O𐶐</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>uid</td>
 *     <td>C</td>
 *     <td>ACR\郆[U[IDw肷Bw莞́AOC[U[Ƃ݂ȂB</td>
 *   </tr>
 *   <tr>
 *     <td>icon</td>
 *     <td>C</td>
 *     <td>Y[U["ICON_UMU"̒lw肷B</td>
 *   </tr>
 *   <tr>
 *     <td>name</td>
 *     <td>C</td>
 *     <td>namepnKvȏꍇAlw肷B</td>
 *   </tr>
 *   <tr>
 *     <td>atr</td>
 *     <td>C</td>
 *     <td>̑̃IvV䐶ꍇ̒lݒ肵܂B</td>
 *   </tr>
 * </table>
 *
 * <p>쌠: Copyright (c) 2011/04/17</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class DispUserIcon extends TagSupport {

  private static final long serialVersionUID = 2523862079191857382L;

  private String _uid = "";
  private String _icon = "";
  private String _name = "";
  private String _atr = "";

  private final String TXT =
    "           <img src=\"{0}\" alt=\"User Icon\" width=\"24px\" height=\"24px\"{1}{2}>";
  private final String DMY_ICON = "_who_.gif";

  /**
   * ^OJnɌĂяo
   *
   * @return <code>EVAL_BODY_TAG</code>
   * @throws JspException
   */
  public int doStartTag() throws JspException {
    if (_uid.length() == 0) {
      UserDto ud = (UserDto)pageContext.getSession().getAttribute(LogInCheck.USER_INF);
      if (ud != null) {
        _uid = ud.getItemValue(UserDto.USER_ID);
        _icon = ud.getItemValue(UserDto.ICON_UMU);
      }
    }
    StringBuilder sb = new StringBuilder();
    sb.append(UserIconMod.ICON_PATH);
    if (_icon.length() > 0) {
      sb.append(_uid);
      sb.append(".");
      sb.append(_icon);
    } else {
      sb.append(DMY_ICON);
    }
    String nm = "";
    if (_name.length() > 0) {
      StringBuilder sb2 = new StringBuilder();
      sb2.append(" name=\"");
      sb2.append(_name);
      sb2.append("\"");
      nm = sb2.toString();
    }
    wrtItem(sb.toString(), nm, _atr);
    release();
    return SKIP_BODY;
  }
  private void wrtItem(String fld, String nm, String val) throws JspException {
    try {
      if (val != null && val.length() > 0) {
        val = " " + val;
      }
      Object[] prm = {fld, nm, val};
      pageContext.getOut().println(MessageFormat.format(TXT, prm));
    } catch (Exception ioe) {
      throw new JspException(ioe.getMessage());
    }
  }

  /**
   * ^OIɌĂяo
   *
   * @return <code>EVAL_PAGE</code>
   * @throws JspException
   */
  public final int doEndTag() throws JspException {
    return EVAL_PAGE;
  }

  /**
   * @param uid Zbg uid
   */
  public void setUid(String uid) {
    _uid = uid;
  }
  /**
   * @param icon Zbg icon
   */
  public void setIcon(String icon) {
    _icon = icon;
  }
  /**
   * @param name Zbg name
   */
  public void setName(String name) {
    _name = name;
  }
  /**
   * @param atr Zbg atr
   */
  public void setAtr(String atr) {
    _atr = atr;
  }
  /**
   * ^O̓ԂZbg
   */
  public void release() {
    _uid = "";
    _icon = "";
    _name = "";
    _atr = "";
    super.release();
  }

}
