package com.hamaf.hikyaku.taglibs;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.util.MessageUtil;


/**
 * <p>^Cg: KeyList̃eLXg̓tB[hp^OuNX.</p>
 * <p>: &lt;input type="text" ... &gt; ^O𐶐Ė߂B</p>
 * <br>ڒlKeyList Object 擾܂B
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>item</td>
 *     <td>K{</td>
 *     <td>鍀ږw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>cls</td>
 *     <td>C</td>
 *     <td><b>class</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>size</td>
 *     <td>C</td>
 *     <td><b>size</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>maxlength</td>
 *     <td>C</td>
 *     <td><b>maxlength</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>ini</td>
 *     <td>C</td>
 *     <td>l̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>attr</td>
 *     <td>C</td>
 *     <td>w肳ꂽl𑮐lƂĒǉ܂B</td>
 *   </tr>
 * </table>
 * <p>쌠: Copyright (c) 2002</p>
 * @author Hamanaka
 * @version 1.0
 */
public class KeyField extends TagSupport {
  
  private static final long serialVersionUID = 3523836371377807751L;
  private static final String VTAG = " value=\"";

  private String _item = null;
  private String _cls = null;
  private String _size = null;
  private String _maxlength = null;
  private String _ini = "";
  private String _attr = "";

  /**
   * ^OJnɌĂяo
   *
   * @return <code>SKIP_BODY</code>
   * @throws JspException
   */
  public int doStartTag() throws JspException {
    //l̊mF
    if (_item == null ) {
      return SKIP_BODY;
    } // end of if ()
    
    StringBuilder sb = new StringBuilder();
    sb.append(MessageUtil.createTextTag(_item, _cls, _size, _maxlength, _attr));
    sb.append(VTAG);
    String kl = MessageUtil.getKeyItem(pageContext.getSession(), _item);
    if (kl == null) {
      sb.append(_ini);
    }
    else {
      sb.append(kl);
    }
    sb.append("\">\n");
    sb.append(MessageUtil.createErrorMsg(pageContext.getRequest(), _item));
    
    try {
      pageContext.getOut().println(sb.toString());
    } catch (Exception ioe) {
      throw new JspException(ioe.getMessage());
    }
    release();
    return SKIP_BODY;
  }

  /**
   * ^OIɌĂяo
   *
   * @return <code>EVAL_PAGE</code>
   * @throws JspException
   */
  public final int doEndTag() throws JspException {
    return EVAL_PAGE;
  }

  /**
   * <CODE>item</CODE>̐ݒ
   * @param item Value to assign to (String)item.
   */
  public final void setItem(String item) {
    _item = item;
  }

  /**
   * <CODE>cls</CODE>̐ݒ
   * @param cls Value to assign to (String)classe.
   */
  public final void setCls(String cls) {
    _cls = cls;
  }

  /**
   * <CODE>size</CODE>̐ݒ
   * @param size Value to assign to (String)size.
   */
  public final void setSize(String size) {
    _size = size;
  }

  /**
   * <CODE>maxlength</CODE>̐ݒ
   * @param maxlength Value to assign to (String)maxlength.
   */
  public final void setMaxlength(String maxlength) {
    _maxlength = maxlength;
  }

  /**
   * <CODE>ini</CODE>̐ݒ
   * @param ini Value to assign to (String)initial value.
   */
  public final void setIni(String ini) {
    _ini = ini;
  }

  /**
   * ^O̓ԂZbg
   */
  public void release() {
    _item = null;
    _cls = null;
    _size = null;
    _maxlength = null;
    _ini = "";
    _attr = "";
    super.release();
  }

  /**
   * @param argAttr attr ݒ肵܂B
   */
  public final void setAttr(String argAttr) {
    _attr = argAttr;
  }
}
