package com.hamaf.hikyaku.taglibs;

import java.text.MessageFormat;
import java.util.Map;

import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.util.MessageUtil;


/**
 * <p>^Cg: \̈̈ꗗp`FbN{bNXtB[hp^OuNX.</p>
 * <p>: ꗗp&lt;input type="checkbox" ... &gt; ^O𐶐Ė߂B</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>pos</td>
 *     <td>K{</td>
 *     <td>ꗗ̃f[^ʒuw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>name</td>
 *     <td>K{</td>
 *     <td><b>name</b>IvṼvtBbNXw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>ini</td>
 *     <td>C</td>
 *     <td>l̒lw肵܂B</td>
 *   </tr>
 * </table>
 * <p>쌠: Copyright (c) 2002</p>
 * @author Hamanaka
 * @version 1.0
 */
public class SpareCheckBox extends TagSupport {

  private static final long serialVersionUID = 2106059334755118919L;
  private static final String CHKTAG =
    "<input type=\"checkbox\" name=\"{0}\" id=\"{0}\" value=\"on\"{1}>\n";
  private static final String CHKON = "on";
  private static final String ATRCHK = " checked";

	private String _pos = null;
  private Map<String, String> _mpos = null;
	private String _name = null;
	private String _ini = "";

	/**
	 * ^OJnɌĂяo
	 *
	 * @return <code>EVAL_BODY_INCLUDE</code>
	 * @throws JspException
	 */
	public int doStartTag() throws JspException {
		//l̊mF
		if (_pos == null ) {
			return SKIP_BODY;
		} // end of if ()

    Object[] prm = new Object[2];
    prm[0] = _name + _pos;
    prm[1] = checkChecked(_pos);

		try {
			pageContext.getOut().println(MessageFormat.format(CHKTAG, prm));
		} catch (Exception ioe) {
			throw new JspException(ioe.getMessage());
		}
    release();
		return SKIP_BODY;
	}

  private String checkChecked(String pos) {
    String val = MessageUtil.getSpare(pageContext.getSession(), compPos());
    if (val == null) {
      val = _ini;
    }
    if (CHKON.equals(val)) {
      return ATRCHK;
    }
    return "";
  }

	/**
	 * ^OIɌĂяo
	 *
	 * @return <code>EVAL_PAGE</code>
	 * @throws JspException
	 */
	public final int doEndTag() throws JspException {
    release();
		return EVAL_PAGE;
	}

  private int compPos() {
    if (_mpos == null) {
      return Integer.parseInt(_pos);
    }
    CommonMessage msg = (CommonMessage)pageContext.getRequest().getAttribute(DistributeServlet.MAPPING_KEY);
    int p = msg.getResList().indexOf(_mpos);
    HttpSession ss = pageContext.getSession();
    KeyList kl = (KeyList)ss.getAttribute((String)ss.getAttribute(DistributeServlet.KEY_SAVE_ID));
    p += kl.getStartPos();
    return p;
  }

	/**
	 * <CODE>pos</CODE>̐ݒ
	 * @param pos Value to assign to (String)pos.
	 */
	public final void setPos(String pos) {
		_pos = pos;
	}
  public final void setPos(Map<String, String> pos) {
    _mpos = pos;
  }

	/**
	 * <CODE>name</CODE>̐ݒ
	 * @param name Value to assign to (String)name.
	 */
	public final void setName(String name) {
		_name = name;
	}

	/**
	 * <CODE>ini</CODE>̐ݒ
	 * @param ini Value to assign to (String)initial value.
	 */
	public final void setIni(String ini) {
    if (ini != null && ini.length() > 0) {
      _ini = CHKON;
    }
	}

	/**
	 * ^O̓ԂZbg
	 */
	public void release() {
		_pos = null;
    _mpos = null;
		_ini = "";
		super.release();
	}

}
