package com.hamaf.hikyaku.ui;

import java.io.File;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.MultiCommonMessage;
import com.hamaf.hikyaku.util.Trace;


/**
 * <p>^Cg:t@CAbv[hiMultipartProcessBasejNX.</p>
 * <p>:NGXgőMꂽAbv[ht@Cevɏ݁A</p>
 * <p>̕ۑpX̏CommonMessageɊi[B</p>
 * <p>쌠: Copyright (c) 2004</p>
 * @author y-hamanaka
 * @version 1.0
 */
public final class FileUpLoad extends MultipartProcessBase {

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    Trace.enter();
    MultiCommonMessage multiMsg = (MultiCommonMessage)msg;

    if (multiMsg.getFileSize() > 0) {
      multiMsg.setResMsg("fileName", getFileName(multiMsg.getFileName()));
      multiMsg.setResMsg("filePass", multiMsg.getFileName().replaceAll("\\\\", "\\\\\\\\"));
      String tempFilePath = multiMsg.getTempFileUrl();
      multiMsg.setResMsg("tempFileName", getFileName(tempFilePath));
      multiMsg.setResMsg("tempFilePath", tempFilePath.replaceAll("\\\\", "\\\\\\\\"));
    }
    else {
      multiMsg.setResMsg("fileName", "");
      multiMsg.setResMsg("filePass", "");
      multiMsg.setResMsg("tempFileName", "");
      multiMsg.setResMsg("tempFilePath", "");
    }
    Trace.exit();
    return multiMsg;
  }

  private String getFileName(String filePath){
    File file = new File(filePath);
    return file.getName();
  }

}
