package com.hamaf.hikyakucms.sample.sns;

import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.sns.dto.NoticeDto;
import com.hamaf.hikyakucms.sample.sns.process.NoticeProcess;

/**
 * <p>^CgFNoticeUtility is .</p>
 * <p>Fm点ʒm@o^pNX</p>
 * <br>OvOCp
 *
 * <p>쌠: Copyright (c) 2011/03/06</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class NoticeUtility {

  private static final String SYSID = "sns";
  /**
   * Describe <code>addNotice</code> method : .
   * <br>m点ʒmo^B
   *
   * @param userId a <code>String</code> : ʒm郆[U[ID
   * @param contents a <code>String</code> : ʒm郁bZ[W
   * @param pluginId a <code>String</code> : ֘A\邽߂ PulaginId
   * @param process a <code>String</code> : ֘A\邽߂ ProcessId
   * @param action a <code>String</code> : ֘A\邽߂ Action
   * @param option a <code>String</code> : ֘A\邽߂ ǉIvV
   * @param entryUserId a <code>String</code> : o^҂̃[U[ID
   * @throws Exception
   */
  public static void addNotice(String userId,
      String contents,
      String pluginId,
      String process,
      String action,
      String option,
      String entryUserId) throws Exception {
    NoticeDto nd = new NoticeDto();
    nd.setItemValue(NoticeDto.USER_ID, userId);
    nd.setItemValue(NoticeDto.CONTENTS, contents);
    nd.setItemValue(NoticeDto.PLUGIN_ID, pluginId);
    nd.setItemValue(NoticeDto.PROCESS_ID, process);
    nd.setItemValue(NoticeDto.ACTION_ID, action);
    nd.setItemValue(NoticeDto.KEY_VALUES, option);
    nd.setItemValue(NoticeDto.ENTRY_USER, entryUserId);
    nd.setItemValue(NoticeDto.ENTRY_DAY, DateUtil.getDate());
    nd.setCommFld(COMMFLD.UUSR, entryUserId);
    Throwable thr = new Throwable();
    StackTraceElement[] stes = thr.getStackTrace();
    nd.setCommFld(COMMFLD.UPGM, stes[1].getClassName());
    nd.setSysId(SYSID);
    NoticeProcess np = new NoticeProcess();
    np.add(nd);
  }

  /**
   * <p>^CgFNOTICE_PARM is .</p>
   * <p>Fm点ʒmo^p̃p[^`</p>
   * <br>
   *
   * <p>쌠: Copyright (c) 2011/03/06</p>
   * @author Yoshinori
   * @version 1.0
   *
   */
  public static enum NOTICE_PARM {UserId, Contents, Plugin, Process, Action, Option, EntryUser};
  /**
   * Describe <code>addNotice</code> method : .
   * <br>m点ʒmo^B
   *
   * @param parm a <code>Map&lt;NOTICE_PARM, String&gt;</code>
   * @throws Exception
   */
  public static void addNotice(Map<NOTICE_PARM, String> parm) throws Exception {
    addNotice(parm.get(NOTICE_PARM.UserId), parm.get(NOTICE_PARM.Contents),
        parm.get(NOTICE_PARM.Plugin), parm.get(NOTICE_PARM.Process), parm.get(NOTICE_PARM.Action),
        parm.get(NOTICE_PARM.Option), parm.get(NOTICE_PARM.EntryUser));
  }
}
