package com.hamaf.hikyakucms.sample.sns.commonUi;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.commonUi.mapping.FootprintsMap;
import com.hamaf.hikyakucms.sample.sns.dto.FootprintsDto;
import com.hamaf.hikyakucms.sample.sns.process.FootprintsProcess;

/**
 * <p>^CgFFootprintsAdd is .</p>
 * <p>FՂ̓o^</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/22</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class FootprintsAdd extends StandardUpdateProcess {

  private FootprintsProcess _fp = null;

  /**
   * Creates a new <code>FootprintsAdd.java</code> instance.
   * <br>Default Constructor
   */
  public FootprintsAdd() {
    _jim = new FootprintsMap();
    _fp = new FootprintsProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new FootprintsDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    dii.setItemValue(FootprintsDto.USER_ID, getUserID());
    _fp.add((FootprintsDto)dii);
    return msg;
  }

}
