package com.hamaf.hikyakucms.sample.sns.managerUi;

import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.dto.ConversationDto;
import com.hamaf.hikyakucms.sample.sns.process.ConversationProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.ConversionMap;

/**
 * <p>^CgFConversationDelete is .</p>
 * <p>FǗҗp⍇폜</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/08</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class ConversationDelete extends StandardUpdateProcess {

  private ConversationProcess _cp = null;

  /**
   * Creates a new <code>ConversationDelete.java</code> instance.
   * <br>Default Constructor
   */
  public ConversationDelete() {
    _jim = new ConversionMap();
    _cp = new ConversationProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new ConversationDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    if (!"all".equals(msg.getReqStr("delType"))) {
      _cp.del((ConversationDto)dii);
      return msg;
    }
    KeyList kyl = (KeyList)super.saveObj;
    for (List<String> keys : kyl) {
      for (int i = 0; i < keys.size(); i++) {
        dii.setItemValue(i, keys.get(i));
      }
      _cp.del((ConversationDto)dii);
    }
    return msg;
  }

}
