package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerDto;
import com.hamaf.hikyakucms.sample.sns.process.AnswerProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.AnswerMap;

/**
 * <p>^CgFAnswerAdd is .</p>
 * <p>F񓚃e[uւ̓o^</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/27</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AnswerAdd extends StandardUpdateProcess {

  private AnswerProcess _ap = null;
  /**
   * Creates a new <code>AnswerAdd.java</code> instance.
   * <br>Default Constructor
   */
  public AnswerAdd() {
    _jim = new AnswerMap();
    _ap = new AnswerProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new AnswerDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    AnswerDto ad = (AnswerDto)dii;
    ad.setItemValue(AnswerDto.USER_ID, getUserID());
    if ("1".equals(msg.getReqStr("multiFlg"))) {
      ad.clearRequest(AnswerDto.Q_SEQNO);
      String[] qseqs = msg.getReqValus("qSeqNo");
      for (int i = 0; i < qseqs.length; i++) {
        ad.addQseqs(qseqs[i]);
      }
    }
    _ap.delAll(ad.getItemValue(AnswerDto.ENQUETE_SEQNO), getUserID(), sysId);
    _ap.regist(ad);
    return msg;
  }

}
