package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardDetailProcess;
import com.hamaf.hikyakucms.sample.sns.dto.BoardDto;
import com.hamaf.hikyakucms.sample.sns.process.BoardProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.BoardMap;

/**
 * <p>^CgFBoardDetail is .</p>
 * <p>Ff̎擾</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/29</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class BoardDetail extends StandardDetailProcess {

  private BoardProcess _bp = null;
  /**
   * Creates a new <code>BoardDetail.java</code> instance.
   * <br>Default Constructor
   */
  public BoardDetail() {
    _jim = new BoardMap();
    _bp = new BoardProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new BoardDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#setKeys(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    dii.setItemValue(BoardDto.GROUP_ID, msg.getReqStr(BoardList.MSG_ID));
    return true;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _bp.getDetail((BoardDto)dii);
  }

}
