﻿package com.hamaf.hikyakucms.sample.wiki.dto;

import com.hamaf.hikyaku.dataobject.RetrieveKeysBase;

/**
 * <p>タイトル：WikiArticleSearchDto is .</p>
 * <p>説明：M_WIKIARTICLE(Wiki記述管理)の検索用データオブジェクト</p>
 * <br>
 *
 * <p>著作権: Copyright ©2012/09/06</p>
 * @author @USR
 * @version 1.0
 */
public class WikiArticleSearchDto extends RetrieveKeysBase {

  public static final int WIKI_NO = 0;
  public static final int CHAPTER = 1;
  public static final int SECTION = 2;
  public static final int SUB_TITLE = 3;
  public static final int PLAIN_TEXT = 4;
  public static final int HTML_TEXT = 5;

}
