﻿package com.hamaf.hikyakucms.sample.wiki.dto;

import com.hamaf.hikyaku.dataobject.RetrieveKeysBase;

/**
 * <p>タイトル：WikiDocSearchDto is .</p>
 * <p>説明：M_WIKIDOC(Wiki文書管理)の検索用データオブジェクト</p>
 * <br>
 *
 * <p>著作権: Copyright ©2012/09/09</p>
 * @author @USR
 * @version 1.0
 */
public class WikiDocSearchDto extends RetrieveKeysBase {

  public static final int WIKI_NO = 0;
  public static final int TITLE = 1;
  public static final int CATEGORY = 2;
  public static final int SAMMARY = 3;
  public static final int DISPLAY_FLAG = 4;
  public static final int AUTHOR = 5;
  public static final int CREATE_DATE = 6;
  public static final int CREATE_TIME = 7;
  public static final int LAST_AUTHOR = 8;
  public static final int LAST_DATE = 9;
  public static final int LAST_TIME = 10;
  public static final int RETVAL = 11;

}
