package com.hamaf.hikyakucms.sample.wiki.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyakucms.sample.wiki.dto.WikiDocSearchDto;
import com.hamaf.hikyakucms.sample.wiki.process.WikiDocProcess;

/**
 * <p>^CgFWkikiReference is .</p>
 * <p>FNڂ̏</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/17</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WkikiReference extends ProcessBase {

  private WikiDocProcess _wdp = null;
  /**
   * Creates a new <code>WkikiReference</code> instance.
   * <br>Default Constructor
   */
  public WkikiReference() {
    _wdp = new WikiDocProcess();
  }

  private final String ACT = "nact";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    String val = msg.getReqStr("refval");
    WikiDocSearchDto wdsd = new WikiDocSearchDto();
    wdsd.setSysId(sysId);
    wdsd.setRetrieveValue(WikiDocSearchDto.TITLE, val);
    wdsd = _wdp.findDoc(wdsd);
    switch (wdsd.getKeys().size()) {
    case 1:
      msg.setResMsg(ACT, "disp");
      msg.setResMsg("wno", wdsd.getKeys().get(0).get(0));
      break;
    case 0:
      wdsd.clearKeys();
      wdsd.setRetrieveValue(WikiDocSearchDto.RETVAL, val);
      wdsd = _wdp.findDoc(wdsd);
      if (wdsd.getKeys().size() == 0) {
        msg.setResMsg(ACT, "addini");
        msg.setResMsg("title", val);
        msg.setResMsg("rmsg", "NꂽWiki͂܂LqĂ܂B Vo^Ē܂񂩁B");
      } else {
        msg.setResMsg(ACT, "list");
        msg.setResMsg("sretval", val);
      }
      break;
    default:
      msg.setResMsg(ACT, "list");
      msg.setResMsg("sretval", val);
      break;
    }
    
    return msg;
  }

}
