package com.hamaf.hikyaku.access;

import java.sql.Connection;
import java.util.Map;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;


/**
 * <p>^CgFConnectFactory is Get DBConnection.</p>
 * <p>FDBRlNV߂܂B</p>
 * <br>MasterXml"DbConnect"^OŋLڂꂽBClass,p[^Conection擾Ė߂B
 * <br>W(w)łTomCatDataSource̓"Hikyaku"Œ`ꂽ̂gp܂B
 * 
 * <p>쌠: Copyright (c) 2007/06/05</p>
 * @author y-hamanaka
 * @version 1.0
 */
public final class ConnectFactory {
  
  private static final String MXTAG = "DbConnect"; 
  private static final String DCCLASS = "class";
  private static final String PRM = "parameter";
  
  /**
   * Describe <code>getConnect</code> method : get Connection.
   * <br>DBRlNV߂܂B
   * <br>DbConnect^OŎw肳ꂽCodel̏AConnection擾Ė߂B
   * 
   * @param key a <code>String</code> : DbConnectCode̒l
   * @param sysId a <code>String</code> : 
   * @return a <code>Connection</code> : 
   * @throws Exception
   */
  public static Connection getConnect(String key, String sysId) throws Exception {
    if (key == null || key.length() == 0) {
      return getDefault(null);
    }
    MasterXmlControl mxs = MasterXmlFactory.newInstance().getMasterXml(sysId);
    try {
      Map<String, String> mdt = mxs.getItemValue(MXTAG, key);
      String cls = mdt.get(DCCLASS);
      if (cls == null || cls.length() == 0) return getDefault(mdt.get(PRM));
      
      DbConnectInterface dci = (DbConnectInterface)Class.forName(mdt.get(DCCLASS)).newInstance();
      return dci.getConnection(mdt.get(PRM));
    } catch (IllegalArgumentException xe) {
    	xe.printStackTrace();
    	return null;
//      return getDefault(null);
    }
  }
  private static Connection getDefault(String prm) throws Exception {
    DbConnectInterface dci = new TomcatPooling();
    return dci.getConnection(prm);
  }

}
