package com.hamaf.hikyaku.access;

import java.sql.SQLException;
import java.sql.Statement;

/**
 * <p>^CgF MultipleAccessBase is Multiple DataBase Accessor Class base.</p>
 * <p>Fe[uXVCommit,RollBackT|[gANZXpNXB</p>
 * <br>ȉ̃\bh`Ă܂B
 * <ol>
 *   <li>getStatement() - <code>Statement</code>擾(ێ܂)
 *   <li>commit() - XVe<b>m</b><code>Connection</code>J
 *   <li>rollBack() - XVe<b>j</b><code>Connection</code>J
 * </ol>
 *
 * <p>Created: Tue Feb 15 14:40:24 2005</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class MultipleAccessBase extends AccessBase {

  /**
   * Describe <code>getStatement</code> method : get DB Statement.
   * <br>Xe[gg@IuWFNg𐶐Ė߂B
   * <br>
   * @return a <code>Statement</code> : Statment
   * @throws SQLException
   */
  protected Statement getStatement() throws SQLException {
    if (_conn == null) {
      throw new SQLException("has not Connection");
    }
    _stmt = null;
    return _conn.createStatement();
  }

  /**
   * Describe <code>commit</code> method : commit and close.
   * <br>݂̃RlNV<b>commit</b>close܂B
   * @exception SQLException if an error occurs
   */
  public final void commit() throws SQLException {
    if (_conn == null) {
      return;
    }
    _conn.commit();
    destroy();
  }

  /**
   * Describe <code>rollBack</code> method : RollBack and colse.
   * <br>݂̃RlNV<b>RollBack</b>close܂B
   * @exception SQLException if an error occurs
   */
  public final void rollBack() throws SQLException {
    if (_conn == null) {
      return;
    }
    _conn.rollback();
    destroy();
  }

}
