package com.hamaf.hikyaku.security.ui;

import java.text.MessageFormat;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.security.access.UserAccess.PWD_FLG;
import com.hamaf.hikyaku.security.process.PasswordUtil;
import com.hamaf.hikyaku.security.process.UserProcess;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFPasswordInitialize is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/03/19</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PasswordInitialize extends ProcessBase {

  private UserProcess _up = null;
  /**
   *  Creates a new <code>PasswordInitialize.java</code> instance.
   * <br>Default Constructor
   */
  public PasswordInitialize(UserProcess up) {
    _up = up;
  }

  private final String MSG_ID = "PwdInitMsg";
  private final String INIT_OK = "PwdInit";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    String pwd = PasswordUtil.initialPassword();
    _up.updatePassword(msg.getReq("uid"), pwd, PWD_FLG.INIT, session);

    Object[] prm = {pwd};
    msg.addMessage(MessageFormat.format(resource.getString(MSG_ID), prm));
    msg.setResMsg("inipw", pwd);
    msg.setResMsg(INIT_OK, "1");
    return msg;
  }

}
