package com.hamaf.hikyaku.security.ui;

import java.io.File;
import java.util.HashMap;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.distribute.ServletUtils;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFUserStyleList is .</p>
 * <p>FX^C̈ꗗ\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/17</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class UserStyleList extends ProcessBase {

  public static final String SKIN_BASE = "skins/";

  private final String IMG_FL = "image.jpg";
  private final String MSG_NM = "name";
  private final String MSG_IMG = "imgpath";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    File bdir = new File(ServletUtils.whichFile(SKIN_BASE));
    File[] child = bdir.listFiles();
    for (int i = 0; i < child.length; i++) {
      File styl = child[i];
      if (styl.isDirectory()) {
        Map<String, String> dt = new HashMap<String, String>();
        dt.put(MSG_NM, styl.getName());
        StringBuilder sb = new StringBuilder();
        sb.append(SKIN_BASE);
        File img = new File(styl, IMG_FL);
        if (img.exists()) {
          sb.append(styl.getName());
          sb.append("/");
        }
        sb.append(IMG_FL);
        dt.put(MSG_IMG, sb.toString());
        msg.addResList(dt);
      }
    }
    return msg;
  }

}
