package com.hamaf.hikyaku.taglibs;

import java.text.MessageFormat;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.util.MessageUtil;


/**
 * <p>^Cg: `FbN{bNXtB[hp^OuNX.</p>
 * <p>: &lt;input type="checkbox" ... &gt; ^O𐶐Ė߂B</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>item</td>
 *     <td>K{</td>
 *     <td>鍀ږw肵܂B</td>
 *   </tr>
 * </table>
 * <p>쌠: Copyright (c) 2002</p>
 * @author Hamanaka
 * @version 1.0
 */
public class CheckBox extends TagSupport {

  private static final long serialVersionUID = 2641567038782938514L;

  private static final String CHKTAG =
    "<input type=\"checkbox\" name=\"{0}\" id=\"{0}\" value=\"{1}\"{2}{3}>\n";
  private static final String CHKON = "1";
  private static final String ATRCHK = " checked";
  private static final String DIS = " disabled";

	private String _item = null;
  private String _ini = null;
  private String _dis = null;
  private String _val = null;

  /**
	 * ^OJnɌĂяo
	 *
	 * @return <code>EVAL_BODY_INCLUDE</code>
	 * @throws JspException
	 */
	public int doStartTag() throws JspException {
		//l̊mF
		if (_item == null ) {
			return SKIP_BODY;
		} // end of if ()

    Object[] prm = new Object[4];
    prm[0] = _item;
    String val = checkValue();
    prm[1] = val;
    prm[2] = checkChecked(val);
    prm[3] = checkDisabled();

		try {
			pageContext.getOut().println(MessageFormat.format(CHKTAG, prm));
		} catch (Exception ioe) {
			throw new JspException(ioe.getMessage());
		}
    release();
		return SKIP_BODY;
	}

  private String checkValue() {
    if (_val == null || _val.length() == 0) return CHKON;
    return _val;
  }

  private String checkChecked(String onval) {
    String val = MessageUtil.getItem(pageContext.getRequest(), _item, false);
    if (val == null) {
      if (_ini != null) return ATRCHK;
    }
    if (onval.equals(val)) {
      return ATRCHK;
    }
    return "";
  }

  private String checkDisabled() {
    if (_dis == null || _dis.length() == 0) return "";
    if (_dis.toLowerCase().startsWith("y") || _dis.toLowerCase().startsWith("t")) return DIS;
    return "";
  }

	/**
	 * ^OIɌĂяo
	 *
	 * @return <code>EVAL_PAGE</code>
	 * @throws JspException
	 */
	public final int doEndTag() throws JspException {
		return EVAL_PAGE;
	}

	/**
	 * <CODE>pos</CODE>̐ݒ
	 * @param pos Value to assign to (String)pos.
	 */
	public final void setItem(String item) {
		_item = item;
	}

	/**
	 * <CODE>ini</CODE>̐ݒ
	 * @param ini Value to assign to (String)initial value.
	 */
	public final void setIni(String ini) {
    if (ini != null && ini.length() > 0) {
      _ini = CHKON;
    }
	}

  /**
   * <CODE>dis</CODE>̐ݒ
   * @param dis Value to assign to (String)dis.
   */
  public final void setDis(String argDis) {
    _dis = argDis;
  }

  /**
   * <CODE>val</CODE>̐ݒ
   * @param val Value to assign to (String)dis.
   */
	public final void setVal(String argVal) {
    _val = argVal;
  }

  /**
	 * ^O̓ԂZbg
	 */
	public void release() {
		_item = null;
		_ini = "";
    _dis = null;
		super.release();
	}

}
