package com.hamaf.hikyaku.taglibs;

import java.text.MessageFormat;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.DistributeServlet;


/**
 * <p>^CgFListCounter is TagLib.</p>
 * <p>Fꗗ\p̃^OuB</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>Ȃ</td>
 *     <td>Ȃ</td>
 *     <td>Ȃ</td>
 *   </tr>
 * </table>
 * <p>쌠: Copyright (c) 2004/10/28</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ListCounter extends TagSupport {

  private static final long serialVersionUID = -12434864492110689L;
  private static final String PAGETAG = "{0} - {1} / {2} ";
  
  /* (Javadoc Ȃ)
   * @see javax.servlet.jsp.tagext.SimpleTagSupport#doTag()
   */
  @Override
  public int doStartTag() throws JspException {
    String proId = (String)pageContext.getSession().getAttribute(DistributeServlet.KEY_SAVE_ID);
    KeyList keyList = (KeyList)pageContext.getSession().getAttribute(proId);
    if (keyList == null || keyList.getDataCount() == 0) {
      return SKIP_BODY;
    }
    Object[] prm = new Object[3];
    prm[0] = Integer.toString(keyList.getStartPos());
    prm[1] = Integer.toString(keyList.getLastPos());
    prm[2] = Integer.toString(keyList.getDataCount());
    try {
      pageContext.getOut().println(MessageFormat.format(PAGETAG, prm));
    } catch (Exception ioe) {
       throw new JspException(ioe.getMessage());
     }
    return SKIP_BODY;
  }

  /**
   * ^OIɌĂяo
   *
   * @return <code>EVAL_PAGE</code>
   * @throws JspException
   */
  public final int doEndTag() throws JspException {
     return EVAL_PAGE;
  }

}
