package com.hamaf.hikyaku.taglibs;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.DynamicAttributes;
import javax.servlet.jsp.tagext.SimpleTagSupport;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.util.TextUtil;


/**
 * <p>^CgFListItemsDsp is List Items Display TagLib.</p>
 * <p>FCommonMessagëꗗp̈悩ꗗ\p̍ڂ̕\s</p>
 * <br>JSP ł̎gp@
 * <br> &lt;tr&gt;
 * <br> @&lt;th&gt;
 * <br> @@ږ0
 * <br> @&lt;/th&gt;
 * <br> @&lt;th&gt;
 * <br> @@ږ1
 * <br> @&lt;/th&gt;
 * <br>@@@E
 * <br>@@@E
 * <br> &lt;/tr&gt;
 * <br>&lt;hky:listItems fld0="ꗗpf[^Key" fld1="ꗗpf[^Key" ... &gt;
 * <br> &lt;tr&gt;
 * <br> @&lt;td&gt;
 * <br> @@${fld0}
 * <br> @&lt;/td&gt;
 * <br> @&lt;td&gt;
 * <br> @@${fld1}
 * <br> @&lt;/td&gt;
 * <br>@@@E
 * <br>@@@E
 * <br> &lt;/tr&gt;
 * <br> &lt;/hky:listItems&gt;
 * 
 * <p>쌠: Copyright (c) 2007/05/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ListItemsDsp extends SimpleTagSupport implements DynamicAttributes {
  
  private List<String[]> _items = new ArrayList<String[]>();

  /* (Javadoc Ȃ)
   * @see javax.servlet.jsp.tagext.SimpleTagSupport#doTag()
   */
  @Override
  public void doTag() throws JspException, IOException {
    PageContext pct = (PageContext)getJspContext();
    Object dt = pct.getRequest().getAttribute(DistributeServlet.MAPPING_KEY);
    if (!(dt instanceof CommonMessage)) {
      return;
    }
    CommonMessage cmsg = (CommonMessage)dt;
    
    for (Map<String, String>mdt : cmsg) {
      for (String[] itm : _items) {
        String val = itm[1];
        if (val.charAt(0) == '#') {
        	val = val.substring(1);
        } else {
          val = TextUtil.cnvJsp(mdt.get(itm[1]), cmsg.getCharCd());
        }
        getJspContext().setAttribute(itm[0], val);
      }
      getJspBody().invoke(null);
    }
  }

  /* (Javadoc Ȃ)
   * @see javax.servlet.jsp.tagext.DynamicAttributes#setDynamicAttribute(java.lang.String, java.lang.String, java.lang.Object)
   */
  public void setDynamicAttribute(String url, String name, Object item)
      throws JspException {
    String[] dt = {name, (String)item};
    _items.add(dt);
  }

}
