package com.hamaf.hikyaku.taglibs;

import java.util.Map;

import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.util.MessageUtil;


/**
 * <p>^Cg: \̈̈ꗗpeLXg̓tB[hp^OuNX.</p>
 * <p>: ꗗp&lt;input type="text" ... &gt; ^O𐶐Ė߂B</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>pos</td>
 *     <td>K{</td>
 *     <td>ꗗ̃f[^ʒuw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>name</td>
 *     <td>K{</td>
 *     <td><b>name</b>IvṼvtBbNXw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>cls</td>
 *     <td>C</td>
 *     <td><b>class</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>size</td>
 *     <td>C</td>
 *     <td><b>size</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>maxlength</td>
 *     <td>C</td>
 *     <td><b>maxlength</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>ini</td>
 *     <td>C</td>
 *     <td>l̒lw肵܂B</td>
 *   </tr>
    <attribute>
       <name>attr</name>
       <required>false</required>
       <rtexprvalue>true</rtexprvalue>
    </attribute>
 * </table>
 * <p>쌠: Copyright (c) 2002</p>
 * @author Hamanaka
 * @version 1.0
 */
public class SpareText extends TagSupport {
  
  private static final long serialVersionUID = 6051154725390102860L;
  private static final String VTAG = " value=\"";

	private String _pos = null;
  private Map<String, String> _mpos = null;
	private String _name = null;
	private String _cls = null;
	private String _size = null;
	private String _maxlength = null;
	private String _ini = "";
  private String _attr = "";

	/**
	 * ^OJnɌĂяo
	 *
	 * @return <code>EVAL_BODY_INCLUDE</code>
	 * @throws JspException
	 */
	public int doStartTag() throws JspException {
		//l̊mF
		if (_pos == null ) {
			return SKIP_BODY;
		} // end of if ()

    String item = _name + _pos;
    StringBuilder sb = new StringBuilder();
    sb.append(MessageUtil.createTextTag(item, _cls, _size, _maxlength, _attr));

		sb.append(VTAG);
    String kl = MessageUtil.getSpare(pageContext.getSession(), compPos());
		if (kl == null) {
			sb.append(_ini);
		}
		else {
			sb.append(kl);
		}
    sb.append("\">\n");
    sb.append(MessageUtil.createErrorMsg(pageContext.getRequest(), item));

		try {
			pageContext.getOut().println(sb.toString());
		} catch (Exception ioe) {
			throw new JspException(ioe.getMessage());
		}
		return SKIP_BODY;
	}

	/**
	 * ^OIɌĂяo
	 *
	 * @return <code>EVAL_PAGE</code>
	 * @throws JspException
	 */
	public final int doEndTag() throws JspException {
    release();
		return EVAL_PAGE;
	}

  private int compPos() {
    if (_mpos == null) {
      return Integer.parseInt(_pos);
    }
    CommonMessage msg = (CommonMessage)pageContext.getRequest().getAttribute(DistributeServlet.MAPPING_KEY);
    int p = msg.getResList().indexOf(_mpos);
    HttpSession ss = pageContext.getSession();
    KeyList kl = (KeyList)ss.getAttribute((String)ss.getAttribute(DistributeServlet.KEY_SAVE_ID));
    p += kl.getStartPos();
    return p;
  }
  
	/**
	 * <CODE>pos</CODE>̐ݒ
	 * @param pos Value to assign to (String)pos.
	 */
	public final void setPos(String pos) {
		_pos = pos;
	}
  public final void setPos(Map<String, String> pos) {
    _mpos = pos;
  }

	/**
	 * <CODE>name</CODE>̐ݒ
	 * @param name Value to assign to (String)name.
	 */
	public final void setName(String name) {
		_name = name;
	}

	/**
	 * <CODE>cls</CODE>̐ݒ
	 * @param cls Value to assign to (String)classe.
	 */
	public final void setCls(String cls) {
		_cls = cls;
	}

	/**
	 * <CODE>size</CODE>̐ݒ
	 * @param size Value to assign to (String)size.
	 */
	public final void setSize(String size) {
		_size = size;
	}

	/**
	 * <CODE>maxlength</CODE>̐ݒ
	 * @param maxlength Value to assign to (String)maxlength.
	 */
	public final void setMaxlength(String maxlength) {
		_maxlength = maxlength;
	}

	/**
	 * <CODE>ini</CODE>̐ݒ
	 * @param ini Value to assign to (String)initial value.
	 */
	public final void setIni(String ini) {
		_ini = ini;
	}

	/**
	 * ^O̓ԂZbg
	 */
	public void release() {
		_pos = null;
    _mpos = null;
		_cls = null;
		_size = null;
		_maxlength = null;
		_ini = "";
    _attr = "";
		super.release();
	}

  /**
   * @param argAttr attr ݒ肵܂B
   */
  public final void setAttr(String argAttr) {
    _attr = argAttr;
  }
}
