package com.hamaf.hikyaku.ui;

import java.util.Set;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.JspItemsMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.extension.ItemChecks;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;


/**
 * <p>^CgFStandardCheckAndUpdate is  WXVp ProcessBase.</p>
 * <p>F̓`FbNDBڍXVp<b>ProcessBase</b>gNXB</p>
 * <br>ȉ̏Lq܂
 * <table border="1" >
 *   <tr bgcolor="#eeeeff">
 *     <td>b\h</td>
 *     <td>K{/C</td>
 *     <td>T</td>
 *   </tr>
 *   <tr>
 *     <td>newDataObj</td>
 *     <td>K{</td>
 *     <td>gpDetaObject<code>Instance</code></tr>
 *   <tr>
 *     <td>callControl</td>
 *     <td>K{</td>
 *     <td>Rg[̌Ăяos</td>
 *   </tr>
 *   <tr>
 *     <td>setFolder</td>
 *     <td>C</td>
 *     <td>`FbNp̃tH_߂
 *        <br>DiContainarɂARXgN^[<b>_cfld</b>ɐݒ肵Ă܂܂B
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>checkMaster</td>
 *     <td>C</td>
 *     <td>}X^Ƃ̃`FbN</td>
 *   </tr>
 *   <tr>
 *     <td>checkRelation</td>
 *     <td>C</td>
 *     <td>ڊԊ֘A`FbN</td>
 *   </tr>
 *   <tr>
 *     <td>setJspMapping</td>
 *     <td>C</td>
 *     <td><b>DetaObject</b>̍ڔԍJSP̍ږ̂̕RtNXo^
 *        <br>DiContainarɂARXgN^[<b>_jim</b>ɐݒ肷ꍇ͕svłB
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>setItems</td>
 *     <td>C</td>
 *     <td><b>DetaObject</b>̍ڔԍJSP̍ږ̂̕Rto^
 *        <br>LA<b>setJspMapping</b>Őݒ肷ꍇ͕svłB
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>setEditValue</td>
 *     <td>C</td>
 *     <td>ҏWsڂDetaObjectɐݒ肷</td>
 *   </tr>
 * </table>
 * <br>DiContainer𗘗pꍇARXgN^ňȉ̈ݒ\łB
 * <ul>
 *   <li>String (ڃ`FbNptH_) : _cfld ɐݒ肷
 *   <li>JspItemsMapping : _jim ɐݒ肷
 * </ul>
 *
 * <p>쌠: Copyright (c) 2007/05/29</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class StandardCheckAndUpdate extends ProcessBase {

  /**
   * _cfld a <code>String</code> : ڃ`FbNp̃tH_[
   */
  protected String _cfld = null;
  /**
   * _jim a <code>JspItemsMapping</code> : JSPږ́Ff[^IuWFNgڑΉNX
   */
  protected JspItemsMapping _jim= null;

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public final CommonMessage exec(CommonMessage msg) throws Exception {
    msg = checkProcess(msg);
    if (msg.getErrorStatus() != STATUS.NORMAL) {
      return msg;
    }

    return updateProcess(msg);
  }

  /**
   * Describe <code>checkProcess</code> method : `FbNs.
   * <ol>
   *   <li>ڃ`FbN<code>(ItemChecks)</code>ɂAڃ`FbNsB
   *      ̍ہA<b>setFolder()</b>tH_[擾B
   *   <li>L`FbNm[}ł΁A}X^`FbN<b>checkMaster()</b>sB
   *   <li>L`FbNm[}ł΁Aڊԃ`FbN<b>checkRelation()</b>sB
   * </ol>
   * @param commonMessage a <code>CommonMessage</code> :
   * @return a <code>CommonMessage</code> :
   * @exception Exception if an error occurs
   */
  private CommonMessage checkProcess(CommonMessage msg) throws Exception {
    msg.setErrorStatus(STATUS.NORMAL);

    if (_cfld == null) {
      _cfld = setFolder();
    }
    if (_cfld != null && _cfld.length() > 0) {
      ItemChecks itc = new ItemChecks();
      msg = itc.check(msg, _cfld);
      if (msg.getErrorStatus() != STATUS.NORMAL) {
        return msg;
      }
    }

    msg = checkMaster(msg);
    if (msg.getErrorStatus() != STATUS.NORMAL) {
      return msg;
    }

    return checkRelation(msg);
  }

  /**
   * Describe <code>updateProcess</code> method : XVs.
   * <ol>
   *   <li><b>setItems()</b>ĂяoA_items<code>(Map)</code>ݒ肷BB
   *   <li><b>newDataObj()</b>A<code>DataObject</code>擾B
   *   <li>DataObjectɍXVe_itemݒ肷B
   *   <li>DataObjectPrimaryKey̒lݒ肷B
   *   <li>ҏWڂ̐ݒ菈<b>setEditValue</b>ĂяoB
   *   <li><b>callControl()</b>ɂăRg[NX̌ĂяosB
   * </ol>
   *
   * @param msg a <code>CommonMessage</code> :
   * @return a <code>CommonMessage</code> :
   * @exception Exception if an error occurs
   */
  private CommonMessage updateProcess(CommonMessage msg) throws Exception {
    if (_jim == null) {
      _jim = setJspMapping();
      if (_jim == null) {
        _jim = new JspItemsMapping();
        setItems();
      }
    }

    DetailItemsInterface  dii = newDataObj();
    setItemValue(msg, dii);
    dii = setEditValue(msg, dii);
    dii.setSysId(sysId);

    msg = callControl(dii, msg);
    return msg;
  }

  /**
   * Describe <code>setFolder</code> method : `FbNp̃tH_[߂.
   * <br>iDiContainaergpRXgN^[Őݒ肷ꍇ́AsvłBj
   * <br>W̍ڃ`FbNsꍇɁA`FbN`ĂtH_[߂܂B
   * <br>{Iɂ́A
   * <br> <code>return "tH_[";</code>
   * <br>Lq܂B
   * @return a <code>String</code> : `FbN`ĂtH_[
   */
  protected String setFolder() {
    return null;
  }

  /**
   * Describe <code>checkMaster</code> method : }X^`FbN.
   * <br>}X^Ȃǂɂ`FbNsꍇɁA<b>Override</b>܂B
   * @param msg a <code>CommonMessage</code> :
   * @return a <code>CommonMessage</code> :
   * @exception Exception if an error occurs
   */
  protected CommonMessage checkMaster(CommonMessage msg) throws Exception {
    return msg;
  }

  /**
   * Describe <code>checkRelation</code> method : ֘A`FbN.
   * <br>ڊԂ̊֘A`FbNKvȏꍇɁA<b>Override</b>܂B
   * @param msg a <code>CommonMessage</code> :
   * @return a <code>CommonMessage</code> :
   * @exception Exception if an error occurs
   */
  protected CommonMessage checkRelation(CommonMessage msg) throws Exception {
    return msg;
  }

  /**
   * Describe <code>setItemValue</code> method : DBXVڂ̐ݒ.
   * <br>NGXg̈̓e_itemɏ]DetaObjectɐݒ肷B
   * <br>r`FbNp̍ڂ̐ݒusB
   * @param msg a <code>CommonMessage</code> :
   * @param dii a <code>DetailItemsInterface</code> :
   */
  private void setItemValue(CommonMessage msg, DetailItemsInterface dii) {
    Set<String> reqnms = msg.getReqKeys();
    for (String fld : _jim) {
      if (reqnms.contains(fld)) {
        dii.setItemValue(_jim.getDtoNo(fld), msg.getReq(fld));
      }
    }
    Set<String> reqfld = msg.getReqKeys();
    for (COMMFLD fld : COMMFLD.values()) {
      if (reqfld.contains(fld.getVal())) {
        dii.setCommFld(fld, msg.getReq(fld.getVal()));
      }
    }
    Object udt = session.getAttribute(LogInCheck.USER_INF);
    if (udt != null && udt instanceof UserDto) {
      dii.setCommFld(COMMFLD.UUSR, ((UserDto)udt).getItemValue(UserDto.USER_ID));
    }
  }

  /**
   * Describe <code>addItem</code> method : 擾ڔԍ:\ږ̗pMapւ̓o^.
   * <br>_items(<code>Map</code>)ɍڔԍJSPł̍ږ̕Rto^B
   * <ol>
   *  <li>key : JSPŎw肳Ă鍀ڂ̖(<code>String</code>)
   *  <li>value : DetailItemsInterfaceNX̍ڔԍ
   * </ol>
   * @param jspnm a <code>String</code> : JSPł̍ږ
   * @param pos an <code>int</code> : f[^ObjectŒ`Ă鍀ڈʒu
   */
  protected final void addItem(String jspnm, int pos) {
    _jim.addItem(jspnm, pos);
  }

  /**
   * Describe <code>setJspMapping</code> method : JSP}bsO̐ݒs.
   * <br>JspItemsMappinǧpNXCX^XA߂B
   * <br>return new xxxMapping();
   */
  protected JspItemsMapping setJspMapping() {
    return null;
  }

  /**
   * Describe <code>setItems</code> method : ڂ̓o^.
   * <br>鍀ڂ<b>DeataObject</b>̒`l(<code>int</code>)JSPł̖̂Ƃ
   *  Rto^B
   * <br>{Iɂ
   * <br> addItem(DataObject.ITEM_NAME, "JSPł̍ږ");
   * <br>ɂĕKvڕARto^sB
   */
  protected void setItems() { }

  /**
   * Describe <code>newDataObj</code> method : gpDetaObject̎߂.
   * <br>gp<b>DataObject</b>CX^XĖ߂B
   * <br>{Iɂ́A return new _DataObject_(); ƂȂ܂B
   * @return a <code>DetailItemsInterface</code> : gpDataObject
   */
  protected abstract DetailItemsInterface newDataObj();

  /**
   * Describe <code>callControl</code> method : Rg[NXĂяo.
   * <br>Rg[NXĂяoAXVsB
   * <br>{Iɂ
   * <br> _Process_Control xcntl = new _Process_Control();
   * <br> xcntl.update(dii);
   * <br> return msg;
   * <br>ƂȂ܂B
   * <br>Kvɉ<code>CommonMessage</code>̐ݒs܂B
   * @param dii a <code>DetailItemsInterface</code> :
   * @param msg a <code>CommonMessage</code> :
   * @return a <code>CommonMessage</code> :
   * @exception Exception if an error occurs
   */
  protected abstract CommonMessage callControl(DetailItemsInterface dii,
                                      CommonMessage msg) throws Exception;

  /**
   * Describe <code>setEditValue</code> method : ҏWڂ̐ݒ.
   * <br>DBɕҏWĐݒ肷鍀ڂꍇɁA<b>override</b>ċLqB
   * @param msg a <code>CommonMessage</code> :
   * @param dii a <code>DetailItemsInterface</code> :
   * @return a <code>DetailItemsInterface</code> :
   * @exception Exception if an error occurs
   */
  protected DetailItemsInterface setEditValue(CommonMessage msg,
                                              DetailItemsInterface dii)
    throws Exception {
    return dii;
  }

}
