package com.hamaf.hikyaku.util;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * <p>^CgFArrayNodeList is Simple NodeList Implementation.</p>
 * <p>FNodeListC^[tF[X̊ȒPȎNX</p>
 *
 * <p>쌠: Copyright (c) 2003/11/20</p>
 * @author Hamanaka
 * @version 1.0
 */
public final class ArrayNodeList implements NodeList {

  List<Node> _nodeList;

  public ArrayNodeList() {
    _nodeList = new ArrayList<Node>();
  }

  /**
   * Describe <code>append</code> method : .
   * <br>
   * @param nd a <code>void</code> :
   */
  public void append(Node nd) {
    _nodeList.add(nd);
  }

  /**
   * @see org.w3c.dom.NodeList#item(int)
   */
  public Node item(int p) {
    return _nodeList.get(p);
  }

  /**
   * @see org.w3c.dom.NodeList#getLength()
   */
  public int getLength() {
    return _nodeList.size();
  }

}
