package com.hamaf.hikyaku.util;

import java.util.Calendar;

/**
 * <p>^CgFStopControl is .</p>
 * <p>F</p>
 * 
 * <p>쌠: Copyright (c) 2004/02/09</p>
 * @author Hamanaka
 * @version 1.0
 */
/**
 * <p>^CgFStopControl is Business Stop Control Process.</p>
 * <p>FƖIyђ~ǗNX</p>
 * <br>~A~͎ԂŊǗ܂B
 * <br>Singltonł̎̂߁AWebTCgƖPʂłȂA
 * <br>r𗘗pĂVXeŜɑ΂Ă̊ǗƂȂ܂B
 *
 * <p>쌠: Copyright (c) 2004/01/31</p>
 * @author Hamanaka
 * @version 1.0
 */
public class StopControl {

  private static StopControl _mySelf = new StopControl();
  private String _jspUrl = "/jsp/system/StopMessage.jsp";
  private Calendar _stopTime = null;
  private Calendar _startTime = null;

  /**
   *  a new <code>StopControl.java</code> instance is checkmate.
   * <br>Default Constructor ł̐}~܂B
   */
  private StopControl() {
  }

  /**
   * Describe <code>newInstance</code> method return MySelf.
   * <br>Singlton p^[ƂĎg߂\bhłB
   * @return a <code>StopControl</code> : myself
   */
  public final static StopControl newInstance() {
    return _mySelf;
  }

  /**
   * Describe <code>setStop</code> method : .
   * <br>
   * @param url a <code>void</code> : 
   */
  /**
   * Describe <code>setStop</code> method : set Stop at promptly.
   * <br>~̐ݒsB
   * @param url a <code>void</code> : ~ɕ\Jspurl.
   */
  public final void setStop(String url) {
    Calendar cln = Calendar.getInstance();
    setStop(cln, url);    
  }

  /**
   * Describe <code>setStart</code> method : set Start at promptly.
   * <br>~̐ݒsB
   */
  public final void setStart() {
    Calendar cln = Calendar.getInstance();
    setStart(cln);    
  }

  /**
   * Describe <code>setStop</code> method : set Stop schedule.
   * <br>~̗\莞Ԃݒ肷B
   * @param tim a <code>Calendar</code> : ~\莞
   * @param url a <code>String</code> : ~ɕ\Jspurl.
   */
  public final void setStop(Calendar tim, String url) {
    if (url != null && url.length() > 0) {
      _jspUrl = url;
    }
    _stopTime = tim;
  }
  
  /**
   * Describe <code>setStart</code> method : set Start schedule.
   * <br>~̗\莞Ԃݒ肷B
   * @param tim a <code>Calendar</code> : ~̗\莞
   */
  public final void setStart(Calendar tim) {
    _startTime = tim;
  }

  /**
   * Describe <code>check</code> method : check stop.
   * <br>~̏ꍇ<code>true</code>Aғ̏ꍇ<code>false</code>߂B
   * @return a <code>boolean</code> : truȅꍇ~
   */
  public final boolean check() {
    if (_stopTime == null) {
      return false;
    }
    Calendar cln = Calendar.getInstance();
    if (cln.before(_stopTime)) {
      return false;
    }
    if (_startTime == null || _startTime.before(_stopTime)) {
      return true;
    }
    if (cln.before(_startTime)) {
      return true;
    }
    return false;
  }

  /**
   * Describe <code>getJspUrl</code> method : return display jsp.
   * <br>~̏ꍇɕ\JSPURL߂B
   * @return a <code>String</code> : ~ɕ\JSPURL
   */
  public final String getJspUrl() {
    return _jspUrl;
  }

  /**
   * Describe <code>getStartTime</code> method : return Stop Time.
   * <br>~\莞Ԃ߂B
   * @return a <code>Calendar</code> : ~\莞
   */
  public final Calendar getStartTime() {
    return _startTime;
  }

  /**
   * Describe <code>getStopTime</code> method : return Start Time.
   * <br>~̗\莞Ԃ߂B
   * @return a <code>Calendar</code> : ~̗\莞
   */
  public final Calendar getStopTime() {
    return _stopTime;
  }

}
