package com.hamaf.hikyakucms.sample.sns.access;

import java.sql.SQLException;
import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;

/**
 * <p>^CgFVCommunecationAccess is .</p>
 * <p>FAr[</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/02/28</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class VCommunecationAccess extends DefaultTableAccess {

  private final String TBLNM = "V_COMMUNICATION";
  private final String TBLNMS = "V_COMMUNICATION_SEARCH";
  private final String PARM = "hsmpl";

  /**
   * Creates a new <code>VCommunecationAccess.java</code> instance.
   * <br>Default Constructor
   */
  public VCommunecationAccess() {
    connectionParameter = PARM;
//    super.setDebug();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#find(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  public RetrieveKeysInterface find(RetrieveKeysInterface rki)
      throws SQLException {
    tableName = TBLNMS;
    return super.find(rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#findByPrimaryKey(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public DetailItemsInterface findByPrimaryKey(DetailItemsInterface dii)
      throws SQLException {
    tableName = TBLNM;
    return super.findByPrimaryKey(dii);
  }

}
