package com.hamaf.hikyakucms.sample.sns.commonUi;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.commonUi.mapping.AppendFileMap;
import com.hamaf.hikyakucms.sample.sns.dto.AppendFileDto;
import com.hamaf.hikyakucms.sample.sns.process.AppendFileProcess;

/**
 * <p>^CgFAppendDelete is .</p>
 * <p>FYtt@C̍폜</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/22</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AppendDelete extends StandardUpdateProcess {

  private final String MSG_OK = "DeleteAppendFile";

  private AppendFileProcess _afp = null;

  /**
   * Creates a new <code>AppendDelete.java</code> instance.
   * <br>Default Constructor
   */
  public AppendDelete() {
    _jim = new AppendFileMap();
    _afp = new AppendFileProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new AppendFileDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _afp.delete((AppendFileDto)dii);
    msg.setResMsg(MSG_OK, "1");
    return msg;
  }

}
