package com.hamaf.hikyakucms.sample.sns.commonUi;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.sns.dto.NoticeDto;
import com.hamaf.hikyakucms.sample.sns.process.NoticeProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.NoticeMap;

/**
 * <p>^CgFNoticeAdd is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/22</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class NoticeAdd extends StandardUpdateProcess {

  private NoticeProcess _np = null;
  /**
   * Creates a new <code>NoticeAdd.java</code> instance.
   * <br>Default Constructor
   */
  public NoticeAdd() {
    _jim = new NoticeMap();
    _np = new NoticeProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new NoticeDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    dii.setItemValue(NoticeDto.ENTRY_DAY, DateUtil.getDate());
    dii.setItemValue(NoticeDto.ENTRY_USER, getUserID());
    _np.add((NoticeDto)dii);
    return msg;
  }

}
