package com.hamaf.hikyakucms.sample.sns.managerUi;

import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.process.EnqueteProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.EnqueteMap;

/**
 * <p>^CgFEnqueteDelete is .</p>
 * <p>FǗҗpAP[g폜</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/04</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class EnqueteDelete extends StandardUpdateProcess {

  private EnqueteProcess _ep = null;

  /**
   * Creates a new <code>EnqueteDelete.java</code> instance.
   * <br>Default Constructor
   */
  public EnqueteDelete() {
    _jim = new EnqueteMap();
    _ep = new EnqueteProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new EnqueteDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    if (!"all".equals(msg.getReqStr("delType"))) {
      delProc(dii);
      return msg;
    }
    KeyList kyl = (KeyList)super.saveObj;
    for (List<String> keys : kyl) {
      for (int i = 0; i < keys.size(); i++) {
        dii.setItemValue(i, keys.get(i));
      }
      delProc(dii);
    }
    return msg;
  }
  private void delProc(DetailItemsInterface dii) throws Exception {
    EnqueteDto ed = (EnqueteDto)dii;
    ed = _ep.findByPrimaryKey(ed);
    _ep.delete(ed);
  }

}
