package com.hamaf.hikyakucms.sample.sns.process;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;
import com.hamaf.hikyakucms.sample.sns.access.GenreAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.GenreDto;
import com.hamaf.hikyakucms.sample.sns.dto.GenreSearchDto;

/**
 * <p>^CgFGenreProcess is .</p>
 * <p>FW̏</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/01</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class GenreProcess {


  private GenreAccess _ga = null;
  private Hatsuban2Access _ha;

 /**
  *  Creates a new <code>GenreProcess.java</code> instance.
  * <br>Default Constructor
  */
 public GenreProcess() {
   _ga = new GenreAccess();
   _ha = new Hatsuban2Access();

//   _ga.setDebug();
 }

 /**
  * Describe <code>find</code> method : .
  * <br>W̌B
  *
  * @param csd a <code>GenreSearchDto</code> :
  * @return a <code>GenreSearchDto</code> :
  * @throws Exception
  */
 public GenreSearchDto find(GenreSearchDto gsd) throws Exception {
   return (GenreSearchDto)_ga.find(gsd);
 }

 /**
  * Describe <code>getDetail</code> method : .
  * <br>W̏ڍ׎擾B
  *
  * @param cd a <code>GenreDto</code> :
  * @return a <code>GenreDto</code> :
  * @throws Exception
  */
 public GenreDto getDetail(GenreDto gd) throws Exception {
   return (GenreDto)_ga.findByPrimaryKey(gd);
 }

 /**
  * Describe <code>regist</code> method : .
  * <br>W̓o^B
  *
  * @param cd a <code>GenreDto</code> :
  * @throws Exception
  */
 public void regist(GenreDto gd) throws Exception {
   gd.setItemValue(GenreDto.GENRE_ID  ,
      _ha.getNextNo(HATSUBAN2_KBN.GENRE, null, gd.getSysId()));
   _ga.regist(gd);
 }

 /**
  * Describe <code>update</code> method : .
  * <br>W̍XVB
  *
  * @param cd a <code>GenreDto</code> :
  * @throws Exception
  */
 public void update(GenreDto gd) throws Exception {
   _ga.update(gd);
 }

 /**
  * Describe <code>delete</code> method : .
  * <br>W̎gpsݒ菈B
  *
  * @param cd a <code>GenreDto</code> :
  * @throws Exception
  */
 public void delete(GenreDto gd) throws Exception {
   gd.setCommFld(COMMFLD.DEL, USE_FLG.DEL.getVal());
   _ga.update(gd);
 }

}
