package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.dto.BoardDto;
import com.hamaf.hikyakucms.sample.sns.process.BoardProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.BoardMap;

/**
 * <p>^CgFBoardUpdate is .</p>
 * <p>Ff̍XV</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/29</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class BoardUpdate extends StandardUpdateProcess {

  private BoardProcess _bp = null;
  /**
   * Creates a new <code>BoardUpdate.java</code> instance.
   * <br>Default Constructor
   */
  public BoardUpdate() {
    _jim = new BoardMap();
    _bp = new BoardProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new BoardDto();
  }

  private final String MSG_OK = "boardUpdate";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _bp.modify((BoardDto)dii);
    msg.setResMsg(MSG_OK, "1");
    return msg;
  }

}
