﻿package com.hamaf.hikyakucms.sample.wiki.dto;

import com.hamaf.hikyaku.dataobject.DetailItemsBase;
import com.hamaf.hikyakucms.sample.wiki.util.WikiArticle;

/**
 * <p>タイトル：WikiArticleDto is .</p>
 * <p>説明：M_WIKIARTICLE(Wiki記述管理)の詳細取得用データオブジェクト</p>
 * <br>
 *
 * <p>著作権: Copyright ©2012/09/06</p>
 * @author @USR
 * @version 1.0
 */
public class WikiArticleDto extends DetailItemsBase {

  public static final int WIKI_NO = 0;
  public static final int CHAPTER = 1;
  public static final int SECTION = 2;
  public static final int SUB_TITLE = 3;
  public static final int PLAIN_TEXT = 4;
  public static final int HTML_TEXT = 5;

  private WikiArticle _article = null;

  public final WikiArticle getArticle() {
    return _article;
  }

  public final void setArticle(WikiArticle article) {
    this._article = article;
  }
}
