package com.hamaf.business.generaldoc.ui;

import com.hamaf.business.generaldoc.dto.AppendFileDto;
import com.hamaf.business.generaldoc.process.AppendFileProcess;
import com.hamaf.business.generaldoc.ui.mapping.AppendFileMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;

/**
 * <p>^CgFCommentMod is .</p>
 * <p>FYtt@C̃RgXV</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/22</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class CommentMod extends StandardUpdateProcess {

  private final String MSG_OK = "ModifyComment";

  private AppendFileProcess _afp = null;

  /**
   * Creates a new <code>CommentMod.java</code> instance.
   * <br>Default Constructor
   */
  public CommentMod() {
    _jim = new AppendFileMap();
    _afp = new AppendFileProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new AppendFileDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _afp.modComment((AppendFileDto)dii);
    msg.setResMsg(MSG_OK, "1");
    return msg;
  }

}
