﻿package com.hamaf.business.workflow.dto;

import com.hamaf.hikyaku.dataobject.RetrieveKeysBase;

/**
 * <p>タイトル：DfAuthorizerSearchDto is .</p>
 * <p>説明：T_DF_AUTHORIZER(ワークフロー承認者情報)の検索用データオブジェクト</p>
 * <br>
 *
 * <p>著作権: Copyright ©2012/10/08</p>
 * @author @USR
 * @version 1.0
 */
public class DfAuthorizerSearchDto extends RetrieveKeysBase {

  public static final int DOCUMENT_NO = 0;
  public static final int AUTHORIZER = 1;
  public static final int AUTHORIZER_KUBUN = 2;
  public static final int DATE_REQUEST = 3;
  public static final int TIME_REQUEST = 4;
  public static final int DATE_APPROVAL = 5;
  public static final int TIME_APPROVAL = 6;
  public static final int STATUS = 7;
  public static final int COMMENT = 8;
  public static final int AGENT = 9;
  public static final int LEVEL = 10;
  public static final int NOTIFICATION = 11;
  public static final int NOTIFICATION_DATE = 12;

}
