package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.DocumentFlowDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.DocumentFlowMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;

/**
 * <p>^CgFRequestCansel is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/17</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class RequestCansel extends StandardUpdateProcess {

  private DocumentFlowProcess _dfp = null;
  
  /**
   * Creates a new <code>RequestCansel</code> instance.
   * <br>Default Constructor
   */
  public RequestCansel() {
    _jim = new DocumentFlowMapping();
    _dfp = new DocumentFlowProcess();
  }

  private final String MSG_END = "F˗܂B";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _dfp.cansellationRequest((DocumentFlowDto)dii);
    msg.addMessage(MSG_END);
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new DocumentFlowDto();
  }

}
